diff --git a/src/bin/pg_rewind/datapagemap.c b/src/bin/pg_rewind/datapagemap.c
index 011693f..022fdba 100644
--- a/src/bin/pg_rewind/datapagemap.c
+++ b/src/bin/pg_rewind/datapagemap.c
@@ -13,6 +13,7 @@
 #include "postgres_fe.h"
 
 #include "datapagemap.h"
+#include "logging.h"
 
 struct datapagemap_iterator
 {
@@ -120,7 +121,7 @@ datapagemap_print(datapagemap_t *map)
 
 	iter = datapagemap_iterate(map);
 	while (datapagemap_next(iter, &blocknum))
-		printf("  blk %u\n", blocknum);
+		pg_log(PG_DEBUG, "  blk %u\n", blocknum);
 
 	pg_free(iter);
 }
diff --git a/src/bin/pg_rewind/filemap.c b/src/bin/pg_rewind/filemap.c
index 895deb1..f2d9a8e 100644
--- a/src/bin/pg_rewind/filemap.c
+++ b/src/bin/pg_rewind/filemap.c
@@ -531,7 +531,8 @@ print_filemap(void)
 		if (entry->action != FILE_ACTION_NONE ||
 			entry->pagemap.bitmapsize > 0)
 		{
-			printf("%s (%s)\n", entry->path, action_to_str(entry->action));
+			pg_log(PG_DEBUG, "%s (%s)\n", entry->path,
+				   action_to_str(entry->action));
 
 			if (entry->pagemap.bitmapsize > 0)
 				datapagemap_print(&entry->pagemap);
diff --git a/src/bin/pg_rewind/pg_rewind.c b/src/bin/pg_rewind/pg_rewind.c
index 96a42f8..be419ba 100644
--- a/src/bin/pg_rewind/pg_rewind.c
+++ b/src/bin/pg_rewind/pg_rewind.c
@@ -466,9 +466,9 @@ getTimelineHistory(ControlFileData *controlFile, int *nentries)
 		int		i;
 
 		if (controlFile == &ControlFile_source)
-			printf("Source timeline history:\n");
+			pg_log(PG_DEBUG, "Source timeline history:\n");
 		else if (controlFile == &ControlFile_target)
-			printf("Target timeline history:\n");
+			pg_log(PG_DEBUG, "Target timeline history:\n");
 		else
 			Assert(false);
 
@@ -480,7 +480,7 @@ getTimelineHistory(ControlFileData *controlFile, int *nentries)
 			TimeLineHistoryEntry *entry;
 
 			entry = &history[i];
-			printf("%d: %X/%X - %X/%X\n", entry->tli,
+			pg_log(PG_DEBUG, "%d: %X/%X - %X/%X\n", entry->tli,
 				(uint32) (entry->begin >> 32), (uint32) (entry->begin),
 				(uint32) (entry->end >> 32), (uint32) (entry->end));
 		}
